{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit ULensLibrary;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, USolver;

type

  { TLensLibrary }

  TLensLibrary = class(TSolver)
  private
    function CalcHash(const AInput: string): Byte;
  public
    procedure ProcessDataLine(const ALine: string); override;
    procedure Finish; override;
    function GetDataFileName: string; override;
    function GetPuzzleName: string; override;
  end;

implementation

{ TLensLibrary }

function TLensLibrary.CalcHash(const AInput: string): Byte;
var
  c: Char;
begin
  Result := 0;
  for c in AInput do
    Result := ((Result + Ord(c)) * 17) and 255;
end;

procedure TLensLibrary.ProcessDataLine(const ALine: string);
var
  split: TStringArray;
  s: string;
begin
  split := ALine.Split(',');
  for s in split do
    Inc(FPart1, CalcHash(s));
end;

procedure TLensLibrary.Finish;
begin

end;

function TLensLibrary.GetDataFileName: string;
begin
  Result := 'lens_library.txt';
end;

function TLensLibrary.GetPuzzleName: string;
begin
  Result := 'Day 15: Lens Library';
end;

end.

